- Identity keys
- Ed25519 + ML-DSA-65 hybrid signatures, generated in the Secure Enclave or StrongBox
- First contact
- PQXDH: X25519 + ML-KEM-1024, combined with HKDF-SHA-256
- Every message
- Double Ratchet + SPQR (ML-KEM-768) for forward secrecy and post-compromise security
- Groups
- MLS RFC 9420 (TreeKEM), new epoch on every join, leave or update
- Payload encryption
- XChaCha20-Poly1305, 256-bit keys, 192-bit nonces
- Data at rest
- Argon2id (RFC 9106) key derivation, XChaCha20-Poly1305, hardware-bound key
- Envelope
- 128-bit random ID, default time to live 24 h (1 h to 7 days), hop limit 8, size buckets 1 / 4 / 32 / 256 KB
- Relay receipt (PCH)
- Ed25519 signature by the relay over envelope ID and time; delivery acknowledgement signed by the recipient inside a sealed reply
- Offline routing
- Store-and-forward with a copy limit per envelope (spray and wait), Bloom-filter summaries so devices never resend what a neighbour already holds
- Radios
- Bluetooth 5 LE (2M and Coded PHY, L2CAP channels), Wi-Fi Aware / Multipeer, optional LoRa
- Salto VPN
- WireGuard + Rosenpass (post-quantum PSK every 2 min), Tor via Arti, Nym Sphinx mixnet, I2P for internal services
- Salto Pass
- W3C VC 2.0 credential, BBS over BLS12-381, Poseidon nullifier per service, accumulator revocation
- Wallet
- PSBT v2, EIP-712, MuSig2, FROST RFC 9591, silent payments BIP-352, stealth addresses ERC-5564
- Shared storage
- Reed-Solomon 10 of 30, client-side encryption, proofs of retrievability every few hours
- Atlas
- H3 resolution 3 to 4, at least 20 devices per published cell, 24 h delay, daily differential-privacy budget